{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Array where

import NET
import qualified NET.System.Type
import qualified Data.Int
import qualified NET.System.Object
--import qualified NET.System.Collections.IComparer
--import qualified NET.System.Collections.IEnumerator

data Array_ a
type Array a = NET.System.Object.Object (Array_ a)

--asReadOnly :: NET.System.Array.Array ( a0) -> IO (NET..ReadOnlyCollection a1)
--asReadOnly arg0 = invokeStatic "System.Array" "AsReadOnly" (arg0)

--resize :: []& a0 -> Int -> IO (())
--resize arg0 arg1 = invokeStatic "System.Array" "Resize" (arg0, arg1)

createInstance :: NET.System.Type.Type a0 -> Int -> IO (NET.System.Array.Array a2)
createInstance arg0 arg1 = invokeStatic "System.Array" "CreateInstance" (arg0, arg1)

createInstance_1 :: NET.System.Type.Type a0 -> Int -> Int -> IO (NET.System.Array.Array a3)
createInstance_1 arg0 arg1 arg2 = invokeStatic "System.Array" "CreateInstance" (arg0, arg1, arg2)

createInstance_2 :: NET.System.Type.Type a0 -> Int -> Int -> Int -> IO (NET.System.Array.Array a4)
createInstance_2 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "CreateInstance" (arg0, arg1, arg2, arg3)

createInstance_3 :: NET.System.Type.Type a0 -> NET.System.Array.Array (Int) -> IO (NET.System.Array.Array a2)
createInstance_3 arg0 arg1 = invokeStatic "System.Array" "CreateInstance" (arg0, arg1)

createInstance_4 :: NET.System.Type.Type a0 -> NET.System.Array.Array (Data.Int.Int64) -> IO (NET.System.Array.Array a2)
createInstance_4 arg0 arg1 = invokeStatic "System.Array" "CreateInstance" (arg0, arg1)

createInstance_5 :: NET.System.Type.Type a0 -> NET.System.Array.Array (Int) -> NET.System.Array.Array (Int) -> IO (NET.System.Array.Array a3)
createInstance_5 arg0 arg1 arg2 = invokeStatic "System.Array" "CreateInstance" (arg0, arg1, arg2)

copy :: NET.System.Array.Array a0 -> NET.System.Array.Array a1 -> Int -> IO (())
copy arg0 arg1 arg2 = invokeStatic "System.Array" "Copy" (arg0, arg1, arg2)

copy_1 :: NET.System.Array.Array a0 -> Int -> NET.System.Array.Array a2 -> Int -> Int -> IO (())
copy_1 arg0 arg1 arg2 arg3 arg4 = invokeStatic "System.Array" "Copy" (arg0, arg1, arg2, arg3, arg4)

constrainedCopy :: NET.System.Array.Array a0 -> Int -> NET.System.Array.Array a2 -> Int -> Int -> IO (())
constrainedCopy arg0 arg1 arg2 arg3 arg4 = invokeStatic "System.Array" "ConstrainedCopy" (arg0, arg1, arg2, arg3, arg4)

copy_2 :: NET.System.Array.Array a0 -> NET.System.Array.Array a1 -> Data.Int.Int64 -> IO (())
copy_2 arg0 arg1 arg2 = invokeStatic "System.Array" "Copy" (arg0, arg1, arg2)

copy_3 :: NET.System.Array.Array a0 -> Data.Int.Int64 -> NET.System.Array.Array a2 -> Data.Int.Int64 -> Data.Int.Int64 -> IO (())
copy_3 arg0 arg1 arg2 arg3 arg4 = invokeStatic "System.Array" "Copy" (arg0, arg1, arg2, arg3, arg4)

clear :: NET.System.Array.Array a0 -> Int -> Int -> IO (())
clear arg0 arg1 arg2 = invokeStatic "System.Array" "Clear" (arg0, arg1, arg2)

getValue :: NET.System.Array.Array (Int) -> Array obj -> IO (NET.System.Object.Object a1)
getValue arg0 = invoke "GetValue" (arg0)

getValue_1 :: Int -> Array obj -> IO (NET.System.Object.Object a1)
getValue_1 arg0 = invoke "GetValue" (arg0)

getValue_2 :: Int -> Int -> Array obj -> IO (NET.System.Object.Object a2)
getValue_2 arg0 arg1 = invoke "GetValue" (arg0, arg1)

getValue_3 :: Int -> Int -> Int -> Array obj -> IO (NET.System.Object.Object a3)
getValue_3 arg0 arg1 arg2 = invoke "GetValue" (arg0, arg1, arg2)

getValue_4 :: Data.Int.Int64 -> Array obj -> IO (NET.System.Object.Object a1)
getValue_4 arg0 = invoke "GetValue" (arg0)

getValue_5 :: Data.Int.Int64 -> Data.Int.Int64 -> Array obj -> IO (NET.System.Object.Object a2)
getValue_5 arg0 arg1 = invoke "GetValue" (arg0, arg1)

getValue_6 :: Data.Int.Int64 -> Data.Int.Int64 -> Data.Int.Int64 -> Array obj -> IO (NET.System.Object.Object a3)
getValue_6 arg0 arg1 arg2 = invoke "GetValue" (arg0, arg1, arg2)

getValue_7 :: NET.System.Array.Array (Data.Int.Int64) -> Array obj -> IO (NET.System.Object.Object a1)
getValue_7 arg0 = invoke "GetValue" (arg0)

setValue :: NET.System.Object.Object a0 -> Int -> Array obj -> IO (())
setValue arg0 arg1 = invoke "SetValue" (arg0, arg1)

setValue_1 :: NET.System.Object.Object a0 -> Int -> Int -> Array obj -> IO (())
setValue_1 arg0 arg1 arg2 = invoke "SetValue" (arg0, arg1, arg2)

setValue_2 :: NET.System.Object.Object a0 -> Int -> Int -> Int -> Array obj -> IO (())
setValue_2 arg0 arg1 arg2 arg3 = invoke "SetValue" (arg0, arg1, arg2, arg3)

setValue_3 :: NET.System.Object.Object a0 -> NET.System.Array.Array (Int) -> Array obj -> IO (())
setValue_3 arg0 arg1 = invoke "SetValue" (arg0, arg1)

setValue_4 :: NET.System.Object.Object a0 -> Data.Int.Int64 -> Array obj -> IO (())
setValue_4 arg0 arg1 = invoke "SetValue" (arg0, arg1)

setValue_5 :: NET.System.Object.Object a0 -> Data.Int.Int64 -> Data.Int.Int64 -> Array obj -> IO (())
setValue_5 arg0 arg1 arg2 = invoke "SetValue" (arg0, arg1, arg2)

setValue_6 :: NET.System.Object.Object a0 -> Data.Int.Int64 -> Data.Int.Int64 -> Data.Int.Int64 -> Array obj -> IO (())
setValue_6 arg0 arg1 arg2 arg3 = invoke "SetValue" (arg0, arg1, arg2, arg3)

setValue_7 :: NET.System.Object.Object a0 -> NET.System.Array.Array (Data.Int.Int64) -> Array obj -> IO (())
setValue_7 arg0 arg1 = invoke "SetValue" (arg0, arg1)

get_Length :: Array obj -> IO (Int)
get_Length = invoke "get_Length" () 

get_LongLength :: Array obj -> IO (Data.Int.Int64)
get_LongLength = invoke "get_LongLength" () 

getLength :: Int -> Array obj -> IO (Int)
getLength arg0 = invoke "GetLength" (arg0)

getLongLength :: Int -> Array obj -> IO (Data.Int.Int64)
getLongLength arg0 = invoke "GetLongLength" (arg0)

get_Rank :: Array obj -> IO (Int)
get_Rank = invoke "get_Rank" () 

getUpperBound :: Int -> Array obj -> IO (Int)
getUpperBound arg0 = invoke "GetUpperBound" (arg0)

getLowerBound :: Int -> Array obj -> IO (Int)
getLowerBound arg0 = invoke "GetLowerBound" (arg0)

get_SyncRoot :: Array obj -> IO (NET.System.Object.Object a0)
get_SyncRoot = invoke "get_SyncRoot" () 

get_IsReadOnly :: Array obj -> IO (Bool)
get_IsReadOnly = invoke "get_IsReadOnly" () 

get_IsFixedSize :: Array obj -> IO (Bool)
get_IsFixedSize = invoke "get_IsFixedSize" () 

get_IsSynchronized :: Array obj -> IO (Bool)
get_IsSynchronized = invoke "get_IsSynchronized" () 

clone :: Array obj -> IO (NET.System.Object.Object a0)
clone = invoke "Clone" () 

binarySearch :: NET.System.Array.Array a0 -> NET.System.Object.Object a1 -> IO (Int)
binarySearch arg0 arg1 = invokeStatic "System.Array" "BinarySearch" (arg0, arg1)

binarySearch_1 :: NET.System.Array.Array a0 -> Int -> Int -> NET.System.Object.Object a3 -> IO (Int)
binarySearch_1 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "BinarySearch" (arg0, arg1, arg2, arg3)

--binarySearch_2 :: NET.System.Array.Array a0 -> NET.System.Object.Object a1 -> NET.System.Collections.IComparer.IComparer a2 -> IO (Int)
--binarySearch_2 arg0 arg1 arg2 = invokeStatic "System.Array" "BinarySearch" (arg0, arg1, arg2)

--binarySearch_3 :: NET.System.Array.Array a0 -> Int -> Int -> NET.System.Object.Object a3 -> NET.System.Collections.IComparer.IComparer a4 -> IO (Int)
--binarySearch_3 arg0 arg1 arg2 arg3 arg4 = invokeStatic "System.Array" "BinarySearch" (arg0, arg1, arg2, arg3, arg4)

binarySearch_4 :: NET.System.Array.Array ( a0) -> Object a1 -> IO (Int)
binarySearch_4 arg0 arg1 = invokeStatic "System.Array" "BinarySearch" (arg0, arg1)

--binarySearch_5 :: NET.System.Array.Array ( a0) ->  a1 -> NET..IComparer`1 a2 -> IO (Int)
--binarySearch_5 arg0 arg1 arg2 = invokeStatic "System.Array" "BinarySearch" (arg0, arg1, arg2)

binarySearch_6 :: NET.System.Array.Array ( a0) -> Int -> Int ->  Object a3 -> IO (Int)
binarySearch_6 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "BinarySearch" (arg0, arg1, arg2, arg3)

--binarySearch_7 :: NET.System.Array.Array ( a0) -> Int -> Int ->  a3 -> NET..IComparer`1 a4 -> IO (Int)
--binarySearch_7 arg0 arg1 arg2 arg3 arg4 = invokeStatic "System.Array" "BinarySearch" (arg0, arg1, arg2, arg3, arg4)

--convertAll :: NET.System.Array.Array (Input a0) -> NET..Converter`2 a1 -> IO (NET.System.Array.Array (Output a2))
--convertAll arg0 arg1 = invokeStatic "System.Array" "ConvertAll" (arg0, arg1)

copyTo :: NET.System.Array.Array a0 -> Int -> Array obj -> IO (())
copyTo arg0 arg1 = invoke "CopyTo" (arg0, arg1)

copyTo_1 :: NET.System.Array.Array a0 -> Data.Int.Int64 -> Array obj -> IO (())
copyTo_1 arg0 arg1 = invoke "CopyTo" (arg0, arg1)

--exists :: NET.System.Array.Array ( a0) -> NET..Predicate`1 a1 -> IO (Bool)
--exists arg0 arg1 = invokeStatic "System.Array" "Exists" (arg0, arg1)

--find :: NET.System.Array.Array ( a0) -> NET..Predicate`1 a1 -> IO ( a2)
--find arg0 arg1 = invokeStatic "System.Array" "Find" (arg0, arg1)

--findAll :: NET.System.Array.Array ( a0) -> NET..Predicate`1 a1 -> IO (NET.System.Array.Array ( a2))
--findAll arg0 arg1 = invokeStatic "System.Array" "FindAll" (arg0, arg1)

--findIndex :: NET.System.Array.Array ( a0) -> NET..Predicate`1 a1 -> IO (Int)
--findIndex arg0 arg1 = invokeStatic "System.Array" "FindIndex" (arg0, arg1)

--findIndex_1 :: NET.System.Array.Array ( a0) -> Int -> NET..Predicate`1 a2 -> IO (Int)
--findIndex_1 arg0 arg1 arg2 = invokeStatic "System.Array" "FindIndex" (arg0, arg1, arg2)

--findIndex_2 :: NET.System.Array.Array ( a0) -> Int -> Int -> NET..Predicate`1 a3 -> IO (Int)
--findIndex_2 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "FindIndex" (arg0, arg1, arg2, arg3)

--findLast :: NET.System.Array.Array ( a0) -> NET..Predicate`1 a1 -> IO ( a2)
--findLast arg0 arg1 = invokeStatic "System.Array" "FindLast" (arg0, arg1)

--findLastIndex :: NET.System.Array.Array ( a0) -> NET..Predicate`1 a1 -> IO (Int)
--findLastIndex arg0 arg1 = invokeStatic "System.Array" "FindLastIndex" (arg0, arg1)

--findLastIndex_1 :: NET.System.Array.Array ( a0) -> Int -> NET..Predicate`1 a2 -> IO (Int)
--findLastIndex_1 arg0 arg1 arg2 = invokeStatic "System.Array" "FindLastIndex" (arg0, arg1, arg2)

--findLastIndex_2 :: NET.System.Array.Array ( a0) -> Int -> Int -> NET..Predicate`1 a3 -> IO (Int)
--findLastIndex_2 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "FindLastIndex" (arg0, arg1, arg2, arg3)

--forEach :: NET.System.Array.Array ( a0) -> NET..Action`1 a1 -> IO (())
--forEach arg0 arg1 = invokeStatic "System.Array" "ForEach" (arg0, arg1)

--getEnumerator :: Array obj -> IO (NET.System.Collections.IEnumerator.IEnumerator a0)
--getEnumerator = invoke "GetEnumerator" () 

indexOf :: NET.System.Array.Array a0 -> NET.System.Object.Object a1 -> IO (Int)
indexOf arg0 arg1 = invokeStatic "System.Array" "IndexOf" (arg0, arg1)

indexOf_1 :: NET.System.Array.Array a0 -> NET.System.Object.Object a1 -> Int -> IO (Int)
indexOf_1 arg0 arg1 arg2 = invokeStatic "System.Array" "IndexOf" (arg0, arg1, arg2)

indexOf_2 :: NET.System.Array.Array a0 -> NET.System.Object.Object a1 -> Int -> Int -> IO (Int)
indexOf_2 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "IndexOf" (arg0, arg1, arg2, arg3)

indexOf_3 :: NET.System.Array.Array ( a0) ->  Object a1 -> IO (Int)
indexOf_3 arg0 arg1 = invokeStatic "System.Array" "IndexOf" (arg0, arg1)

indexOf_4 :: NET.System.Array.Array ( a0) ->  Object a1 -> Int -> IO (Int)
indexOf_4 arg0 arg1 arg2 = invokeStatic "System.Array" "IndexOf" (arg0, arg1, arg2)

indexOf_5 :: NET.System.Array.Array ( a0) ->  Object a1 -> Int -> Int -> IO (Int)
indexOf_5 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "IndexOf" (arg0, arg1, arg2, arg3)

lastIndexOf :: NET.System.Array.Array a0 -> NET.System.Object.Object a1 -> IO (Int)
lastIndexOf arg0 arg1 = invokeStatic "System.Array" "LastIndexOf" (arg0, arg1)

lastIndexOf_1 :: NET.System.Array.Array a0 -> NET.System.Object.Object a1 -> Int -> IO (Int)
lastIndexOf_1 arg0 arg1 arg2 = invokeStatic "System.Array" "LastIndexOf" (arg0, arg1, arg2)

lastIndexOf_2 :: NET.System.Array.Array a0 -> NET.System.Object.Object a1 -> Int -> Int -> IO (Int)
lastIndexOf_2 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "LastIndexOf" (arg0, arg1, arg2, arg3)

lastIndexOf_3 :: NET.System.Array.Array ( a0) ->  Object a1 -> IO (Int)
lastIndexOf_3 arg0 arg1 = invokeStatic "System.Array" "LastIndexOf" (arg0, arg1)

lastIndexOf_4 :: NET.System.Array.Array ( a0) ->  Object a1 -> Int -> IO (Int)
lastIndexOf_4 arg0 arg1 arg2 = invokeStatic "System.Array" "LastIndexOf" (arg0, arg1, arg2)

lastIndexOf_5 :: NET.System.Array.Array ( a0) ->  Object a1 -> Int -> Int -> IO (Int)
lastIndexOf_5 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "LastIndexOf" (arg0, arg1, arg2, arg3)

reverse :: NET.System.Array.Array a0 -> IO (())
reverse arg0 = invokeStatic "System.Array" "Reverse" (arg0)

reverse_1 :: NET.System.Array.Array a0 -> Int -> Int -> IO (())
reverse_1 arg0 arg1 arg2 = invokeStatic "System.Array" "Reverse" (arg0, arg1, arg2)

sort :: NET.System.Array.Array a0 -> IO (())
sort arg0 = invokeStatic "System.Array" "Sort" (arg0)

sort_1 :: NET.System.Array.Array a0 -> NET.System.Array.Array a1 -> IO (())
sort_1 arg0 arg1 = invokeStatic "System.Array" "Sort" (arg0, arg1)

sort_2 :: NET.System.Array.Array a0 -> Int -> Int -> IO (())
sort_2 arg0 arg1 arg2 = invokeStatic "System.Array" "Sort" (arg0, arg1, arg2)

sort_3 :: NET.System.Array.Array a0 -> NET.System.Array.Array a1 -> Int -> Int -> IO (())
sort_3 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "Sort" (arg0, arg1, arg2, arg3)

--sort_4 :: NET.System.Array.Array a0 -> NET.System.Collections.IComparer.IComparer a1 -> IO (())
--sort_4 arg0 arg1 = invokeStatic "System.Array" "Sort" (arg0, arg1)

--sort_5 :: NET.System.Array.Array a0 -> NET.System.Array.Array a1 -> NET.System.Collections.IComparer.IComparer a2 -> IO (())
--sort_5 arg0 arg1 arg2 = invokeStatic "System.Array" "Sort" (arg0, arg1, arg2)

--sort_6 :: NET.System.Array.Array a0 -> Int -> Int -> NET.System.Collections.IComparer.IComparer a3 -> IO (())
--sort_6 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "Sort" (arg0, arg1, arg2, arg3)

--sort_7 :: NET.System.Array.Array a0 -> NET.System.Array.Array a1 -> Int -> Int -> NET.System.Collections.IComparer.IComparer a4 -> IO (())
--sort_7 arg0 arg1 arg2 arg3 arg4 = invokeStatic "System.Array" "Sort" (arg0, arg1, arg2, arg3, arg4)

sort_8 :: NET.System.Array.Array ( a0) -> IO (())
sort_8 arg0 = invokeStatic "System.Array" "Sort" (arg0)

--sort_9 :: NET.System.Array.Array (Key a0) -> NET.System.Array.Array (Value a1) -> IO (())
--sort_9 arg0 arg1 = invokeStatic "System.Array" "Sort" (arg0, arg1)

sort_10 :: NET.System.Array.Array ( a0) -> Int -> Int -> IO (())
sort_10 arg0 arg1 arg2 = invokeStatic "System.Array" "Sort" (arg0, arg1, arg2)

--sort_11 :: NET.System.Array.Array (Key a0) -> NET.System.Array.Array (Value a1) -> Int -> Int -> IO (())
--sort_11 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "Sort" (arg0, arg1, arg2, arg3)

--sort_12 :: NET.System.Array.Array ( a0) -> NET..IComparer`1 a1 -> IO (())
--sort_12 arg0 arg1 = invokeStatic "System.Array" "Sort" (arg0, arg1)

--sort_13 :: NET.System.Array.Array (Key a0) -> NET.System.Array.Array (Value a1) -> NET..IComparer`1 a2 -> IO (())
--sort_13 arg0 arg1 arg2 = invokeStatic "System.Array" "Sort" (arg0, arg1, arg2)

--sort_14 :: NET.System.Array.Array ( a0) -> Int -> Int -> NET..IComparer`1 a3 -> IO (())
--sort_14 arg0 arg1 arg2 arg3 = invokeStatic "System.Array" "Sort" (arg0, arg1, arg2, arg3)

--sort_15 :: NET.System.Array.Array (Key a0) -> NET.System.Array.Array (Value a1) -> Int -> Int -> NET..IComparer`1 a4 -> IO (())
--sort_15 arg0 arg1 arg2 arg3 arg4 = invokeStatic "System.Array" "Sort" (arg0, arg1, arg2, arg3, arg4)

--sort_16 :: NET.System.Array.Array ( a0) -> NET..Comparison`1 a1 -> IO (())
--sort_16 arg0 arg1 = invokeStatic "System.Array" "Sort" (arg0, arg1)

--trueForAll :: NET.System.Array.Array ( a0) -> NET..Predicate`1 a1 -> IO (Bool)
--trueForAll arg0 arg1 = invokeStatic "System.Array" "TrueForAll" (arg0, arg1)

initialize :: Array obj -> IO (())
initialize = invoke "Initialize" () 


