{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.AsyncCallback ( module NET.System.AsyncCallback ) where

import qualified NET
import NET.System.AsyncCallback.Type as NET.System.AsyncCallback
import qualified NET.System.IAsyncResult.Type as NET.System.IAsyncResult
import qualified NET.System.Object
import qualified NET.System.MulticastDelegate.Type as NET.System.MulticastDelegate

invoke :: (NET.System.IAsyncResult.IAsyncResult a0) => NET.System.Object.Object a0 -> AsyncCallback obj -> IO (())
invoke arg0 = NET.invoke "Invoke" (arg0)

beginInvoke :: (NET.System.IAsyncResult.IAsyncResult a0, NET.System.IAsyncResult.IAsyncResult a3) => NET.System.Object.Object a0 -> NET.System.AsyncCallback.AsyncCallback a1 -> NET.System.Object.Object a2 -> AsyncCallback obj -> IO (NET.System.Object.Object a3)
beginInvoke arg0 arg1 arg2 = NET.invoke "BeginInvoke" (arg0, arg1, arg2)

endInvoke :: (NET.System.IAsyncResult.IAsyncResult a0) => NET.System.Object.Object a0 -> AsyncCallback obj -> IO (())
endInvoke arg0 = NET.invoke "EndInvoke" (arg0)


