{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Collections.Generic.Dictionary.Enumerator ( module NET.System.Collections.Generic.Dictionary.Enumerator ) where

import qualified NET
import NET.System.Collections.Generic.Dictionary.Enumerator.Type as NET.System.Collections.Generic.Dictionary.Enumerator
import qualified NET.System.Collections.Generic.KeyValuePair.Type as NET.System.Collections.Generic.KeyValuePair
import qualified NET.System.ValueType.Type as NET.System.ValueType

moveNext :: (NET.Type gTKey, NET.Type gTValue) => Enumerator obj  gTKey gTValue -> IO (Bool)
moveNext obj = NET.invokeGeneric "MoveNext" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  ()  obj

get_Current :: (NET.Type gTKey, NET.Type gTValue) => Enumerator obj  gTKey gTValue -> IO (NET.System.Collections.Generic.KeyValuePair.KeyValuePair a0 gTKey gTValue)
get_Current obj = NET.invokeGeneric "get_Current" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  NET.tyMethSplit $  [])  ()  obj

dispose :: (NET.Type gTKey, NET.Type gTValue) => Enumerator obj  gTKey gTValue -> IO (())
dispose obj = NET.invokeGeneric "Dispose" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  ()  obj


