{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Collections.Generic.IList ( module NET.System.Collections.Generic.IList ) where

import qualified NET
import NET.System.Collections.Generic.IList.Type as NET.System.Collections.Generic.IList
import qualified Data.Int
import qualified NET.System.Object

get_Item :: (NET.Type gT, NET.Result gT, IList obj) => Data.Int.Int32 -> NET.Object (objTy obj  gT) -> IO (gT)
get_Item arg0 obj = NET.invokeGeneric "get_Item" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

set_Item :: (NET.Type gT, NET.Arg gT, IList obj) => Data.Int.Int32 -> gT -> NET.Object (objTy obj  gT) -> IO (())
set_Item arg0 arg1 obj = NET.invokeGeneric "set_Item" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

indexOf :: (NET.Type gT, NET.Arg gT, IList obj) => gT -> NET.Object (objTy obj  gT) -> IO (Data.Int.Int32)
indexOf arg0 obj = NET.invokeGeneric "IndexOf" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

insert :: (NET.Type gT, NET.Arg gT, IList obj) => Data.Int.Int32 -> gT -> NET.Object (objTy obj  gT) -> IO (())
insert arg0 arg1 obj = NET.invokeGeneric "Insert" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

removeAt :: (NET.Type gT, IList obj) => Data.Int.Int32 -> NET.Object (objTy obj  gT) -> IO (())
removeAt arg0 obj = NET.invokeGeneric "RemoveAt" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  (arg0) obj


