{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Collections.ICollection ( module NET.System.Collections.ICollection ) where

import qualified NET
import NET.System.Collections.ICollection.Type as NET.System.Collections.ICollection
import qualified NET.System.Array
import qualified Data.Int
import qualified NET.System.Object

copyTo :: (ICollection obj) => NET.System.Array.Array a0 -> Data.Int.Int32 -> NET.Object (objTy obj ) -> IO (())
copyTo arg0 arg1 obj = NET.invoke "CopyTo"  (arg0, arg1) obj

get_Count :: (ICollection obj) => NET.Object (objTy obj ) -> IO (Data.Int.Int32)
get_Count obj = NET.invoke "get_Count"  ()  obj

get_SyncRoot :: (ICollection obj) => NET.Object (objTy obj ) -> IO (NET.Object (objTy0 a0))
get_SyncRoot obj = NET.invoke "get_SyncRoot"  ()  obj

get_IsSynchronized :: (ICollection obj) => NET.Object (objTy obj ) -> IO (Bool)
get_IsSynchronized obj = NET.invoke "get_IsSynchronized"  ()  obj


