{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Collections.IList ( module NET.System.Collections.IList ) where

import qualified NET
import NET.System.Collections.IList.Type as NET.System.Collections.IList
import qualified Data.Int
import qualified NET.System.Object

get_Item :: (IList obj) => Data.Int.Int32 -> NET.Object (objTy obj ) -> IO (NET.Object (objTy1 a1))
get_Item arg0 obj = NET.invoke "get_Item"  (arg0) obj

set_Item :: (IList obj) => Data.Int.Int32 -> NET.Object (objTy1 a1) -> NET.Object (objTy obj ) -> IO (())
set_Item arg0 arg1 obj = NET.invoke "set_Item"  (arg0, arg1) obj

add :: (IList obj) => NET.Object (objTy0 a0) -> NET.Object (objTy obj ) -> IO (Data.Int.Int32)
add arg0 obj = NET.invoke "Add"  (arg0) obj

contains :: (IList obj) => NET.Object (objTy0 a0) -> NET.Object (objTy obj ) -> IO (Bool)
contains arg0 obj = NET.invoke "Contains"  (arg0) obj

clear :: (IList obj) => NET.Object (objTy obj ) -> IO (())
clear obj = NET.invoke "Clear"  ()  obj

get_IsReadOnly :: (IList obj) => NET.Object (objTy obj ) -> IO (Bool)
get_IsReadOnly obj = NET.invoke "get_IsReadOnly"  ()  obj

get_IsFixedSize :: (IList obj) => NET.Object (objTy obj ) -> IO (Bool)
get_IsFixedSize obj = NET.invoke "get_IsFixedSize"  ()  obj

indexOf :: (IList obj) => NET.Object (objTy0 a0) -> NET.Object (objTy obj ) -> IO (Data.Int.Int32)
indexOf arg0 obj = NET.invoke "IndexOf"  (arg0) obj

insert :: (IList obj) => Data.Int.Int32 -> NET.Object (objTy1 a1) -> NET.Object (objTy obj ) -> IO (())
insert arg0 arg1 obj = NET.invoke "Insert"  (arg0, arg1) obj

remove :: (IList obj) => NET.Object (objTy0 a0) -> NET.Object (objTy obj ) -> IO (())
remove arg0 obj = NET.invoke "Remove"  (arg0) obj

removeAt :: (IList obj) => Data.Int.Int32 -> NET.Object (objTy obj ) -> IO (())
removeAt arg0 obj = NET.invoke "RemoveAt"  (arg0) obj


