{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Collections.ObjectModel.ReadOnlyCollection ( module NET.System.Collections.ObjectModel.ReadOnlyCollection ) where

import qualified NET
import NET.System.Collections.ObjectModel.ReadOnlyCollection.Type as NET.System.Collections.ObjectModel.ReadOnlyCollection
import qualified Data.Int
import qualified NET.System.Array
import qualified NET.System.Collections.Generic.IEnumerator.Type as NET.System.Collections.Generic.IEnumerator
import qualified NET.System.Object

get_Count :: (NET.Type gT) => ReadOnlyCollection obj  gT -> IO (Data.Int.Int32)
get_Count obj = NET.invokeGeneric "get_Count" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  ()  obj

get_Item :: (NET.Type gT, NET.Result gT) => Data.Int.Int32 -> ReadOnlyCollection obj  gT -> IO (gT)
get_Item arg0 obj = NET.invokeGeneric "get_Item" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

contains :: (NET.Type gT, NET.Arg gT) => gT -> ReadOnlyCollection obj  gT -> IO (Bool)
contains arg0 obj = NET.invokeGeneric "Contains" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

copyTo :: (NET.Type gT, NET.Arg gT) => NET.System.Array.Array (gT) -> Data.Int.Int32 -> ReadOnlyCollection obj  gT -> IO (())
copyTo arg0 arg1 obj = NET.invokeGeneric "CopyTo" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

getEnumerator :: (NET.Type gT, NET.System.Collections.Generic.IEnumerator.IEnumerator (objTy_0 t0  gT)) => ReadOnlyCollection obj  gT -> IO (NET.Object (objTy_0 t0  gT))
getEnumerator obj = NET.invokeGeneric "GetEnumerator" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  NET.tyMethSplit $  [])  ()  obj

indexOf :: (NET.Type gT, NET.Arg gT) => gT -> ReadOnlyCollection obj  gT -> IO (Data.Int.Int32)
indexOf arg0 obj = NET.invokeGeneric "IndexOf" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj


