{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Globalization.NumberStyles where

import NET
import qualified System.IO.Unsafe
import qualified NET.System.Type
import qualified NET.System.Enum

type NumberStyles a = Int

data NumberStylesTy
 = None
 | AllowLeadingWhite
 | AllowTrailingWhite
 | AllowLeadingSign
 | AllowTrailingSign
 | AllowParentheses
 | AllowDecimalPoint
 | AllowThousands
 | AllowExponent
 | AllowCurrencySymbol
 | AllowHexSpecifier
 | Integer
 | HexNumber
 | Number
 | Float
 | Currency
 | Any
  deriving ( Enum, Show, Read )
toNumberStyles :: NumberStylesTy -> NumberStyles ()
toNumberStyles tag = fromEnum tag

fromNumberStyles :: NumberStyles () -> NumberStylesTy
fromNumberStyles obj = toEnum obj

