{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Linq.Enumerable ( module NET.System.Linq.Enumerable ) where

import qualified NET
import NET.System.Linq.Enumerable.Type as NET.System.Linq.Enumerable
import qualified NET.System.Func
import qualified NET.System.Collections.Generic.IEnumerable.Type as NET.System.Collections.Generic.IEnumerable
import qualified Data.Int
import qualified NET.System.Collections.Generic.IEqualityComparer.Type as NET.System.Collections.Generic.IEqualityComparer
import qualified NET.System.Linq.IOrderedEnumerable.Type as NET.System.Linq.IOrderedEnumerable
import qualified NET.System.Collections.Generic.IComparer.Type as NET.System.Collections.Generic.IComparer
import qualified NET.System.Linq.IGrouping.Type as NET.System.Linq.IGrouping
import qualified NET.System.Array
import qualified NET.System.Collections.Generic.List.Type as NET.System.Collections.Generic.List
import qualified NET.System.Collections.Generic.Dictionary.Type as NET.System.Collections.Generic.Dictionary
import qualified NET.System.Linq.ILookup.Type as NET.System.Linq.ILookup
import qualified NET.System.Collections.IEnumerable.Type as NET.System.Collections.IEnumerable
import qualified NET.System.Nullable.Type as NET.System.Nullable
import qualified NET.System.Decimal.Type as NET.System.Decimal
import qualified NET.System.Object

whereQ :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
whereQ arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Where" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

where_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => ( ( gTSource, Data.Int.Int32) -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
where_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Where" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

select :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTResult)) => ( gTSource -> IO  gTResult) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTResult))
select arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Select" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

select_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTResult)) => ( ( gTSource, Data.Int.Int32) -> IO  gTResult) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTResult))
select_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Select" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

selectMany :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_11 t11  gTResult), NET.Type (objTy_11 t11  gTResult), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTResult)) => ( gTSource -> IO  (NET.Object (objTy_11 t11  gTResult))) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTResult))
selectMany arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "SelectMany" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11  $ {-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

selectMany_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_11 t11  gTResult), NET.Type (objTy_11 t11  gTResult), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTResult)) => ( ( gTSource, Data.Int.Int32) -> IO  (NET.Object (objTy_11 t11  gTResult))) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTResult))
selectMany_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "SelectMany" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11  $ {-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

selectMany_2 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTCollection, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_11 t11  gTCollection), NET.Type (objTy_11 t11  gTCollection), NET.Arg gTCollection, NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_3 t3  gTResult)) => ( ( gTSource, Data.Int.Int32) -> IO  (NET.Object (objTy_11 t11  gTCollection))) -> ( ( gTSource, gTCollection) -> IO  gTResult) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTResult))
selectMany_2 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "SelectMany" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11  $ {-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg2) $  [])  (arg0, arg1, arg2)

selectMany_3 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTCollection, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_11 t11  gTCollection), NET.Type (objTy_11 t11  gTCollection), NET.Arg gTCollection, NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_3 t3  gTResult)) => ( gTSource -> IO  (NET.Object (objTy_11 t11  gTCollection))) -> ( ( gTSource, gTCollection) -> IO  gTResult) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTResult))
selectMany_3 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "SelectMany" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11  $ {-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg2) $  [])  (arg0, arg1, arg2)

take :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => Data.Int.Int32 -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
take arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Take" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

takeWhile :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
takeWhile arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "TakeWhile" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

takeWhile_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => ( ( gTSource, Data.Int.Int32) -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
takeWhile_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "TakeWhile" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

skip :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => Data.Int.Int32 -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
skip arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Skip" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

skipWhile :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
skipWhile arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "SkipWhile" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

skipWhile_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => ( ( gTSource, Data.Int.Int32) -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
skipWhile_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "SkipWhile" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

join :: (NET.Type gTInner, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTInner), NET.Type gTOuter, NET.Arg gTOuter, NET.Type gTKey, NET.Result gTKey, NET.Arg gTInner, NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTOuter), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_5 t5  gTResult)) => NET.Object (objTy_1 t1  gTInner) -> ( gTOuter -> IO  gTKey) -> ( gTInner -> IO  gTKey) -> ( ( gTOuter, gTInner) -> IO  gTResult) -> NET.Object (objTy_0 t0  gTOuter)-> IO (NET.Object (objTy_5 t5  gTResult))
join arg1 arg2 arg3 arg4 arg0 = NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.System.Func.newFunc (\ a _obj -> arg3 a) >>= \ arg3 ->  NET.System.Func.newFunc (\ a _obj -> arg4 a) >>= \ arg4 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Join" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  NET.tyNameCons ({-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg4) $  [])  (arg0, arg1, arg2, arg3, arg4)

join_1 :: (NET.Type gTInner, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTInner), NET.Type gTOuter, NET.Arg gTOuter, NET.Type gTKey, NET.Result gTKey, NET.Arg gTInner, NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_5 t5  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTOuter), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_6 t6  gTResult)) => NET.Object (objTy_1 t1  gTInner) -> ( gTOuter -> IO  gTKey) -> ( gTInner -> IO  gTKey) -> ( ( gTOuter, gTInner) -> IO  gTResult) -> NET.Object (objTy_5 t5  gTKey) -> NET.Object (objTy_0 t0  gTOuter)-> IO (NET.Object (objTy_6 t6  gTResult))
join_1 arg1 arg2 arg3 arg4 arg5 arg0 = NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.System.Func.newFunc (\ a _obj -> arg3 a) >>= \ arg3 ->  NET.System.Func.newFunc (\ a _obj -> arg4 a) >>= \ arg4 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Join" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  NET.tyNameCons ({-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg4) $  [])  (arg0, arg1, arg2, arg3, arg4, arg5)

groupJoin :: (NET.Type gTInner, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTInner), NET.Type gTOuter, NET.Arg gTOuter, NET.Type gTKey, NET.Result gTKey, NET.Arg gTInner, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_41 t41  gTInner), NET.Type (objTy_41 t41  gTInner), NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTOuter), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_5 t5  gTResult)) => NET.Object (objTy_1 t1  gTInner) -> ( gTOuter -> IO  gTKey) -> ( gTInner -> IO  gTKey) -> ( ( gTOuter, (NET.Object (objTy_41 t41  gTInner))) -> IO  gTResult) -> NET.Object (objTy_0 t0  gTOuter)-> IO (NET.Object (objTy_5 t5  gTResult))
groupJoin arg1 arg2 arg3 arg4 arg0 = NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.System.Func.newFunc (\ a _obj -> arg3 a) >>= \ arg3 ->  NET.System.Func.newFunc (\ a _obj -> arg4 a) >>= \ arg4 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "GroupJoin" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  NET.tyNameCons ({-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg4) $  [])  (arg0, arg1, arg2, arg3, arg4)

groupJoin_1 :: (NET.Type gTInner, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTInner), NET.Type gTOuter, NET.Arg gTOuter, NET.Type gTKey, NET.Result gTKey, NET.Arg gTInner, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_41 t41  gTInner), NET.Type (objTy_41 t41  gTInner), NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_5 t5  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTOuter), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_6 t6  gTResult)) => NET.Object (objTy_1 t1  gTInner) -> ( gTOuter -> IO  gTKey) -> ( gTInner -> IO  gTKey) -> ( ( gTOuter, (NET.Object (objTy_41 t41  gTInner))) -> IO  gTResult) -> NET.Object (objTy_5 t5  gTKey) -> NET.Object (objTy_0 t0  gTOuter)-> IO (NET.Object (objTy_6 t6  gTResult))
groupJoin_1 arg1 arg2 arg3 arg4 arg5 arg0 = NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.System.Func.newFunc (\ a _obj -> arg3 a) >>= \ arg3 ->  NET.System.Func.newFunc (\ a _obj -> arg4 a) >>= \ arg4 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "GroupJoin" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  NET.tyNameCons ({-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg4) $  [])  (arg0, arg1, arg2, arg3, arg4, arg5)

orderBy :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_2 t2  gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
orderBy arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "OrderBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

orderBy_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IComparer.IComparer (objTy_2 t2  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_3 t3  gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_2 t2  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTSource))
orderBy_1 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "OrderBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1, arg2)

orderByDescending :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_2 t2  gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
orderByDescending arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "OrderByDescending" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

orderByDescending_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IComparer.IComparer (objTy_2 t2  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_3 t3  gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_2 t2  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTSource))
orderByDescending_1 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "OrderByDescending" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1, arg2)

thenBy :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_2 t2  gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
thenBy arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ThenBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

thenBy_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IComparer.IComparer (objTy_2 t2  gTKey), NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_3 t3  gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_2 t2  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTSource))
thenBy_1 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ThenBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1, arg2)

thenByDescending :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_2 t2  gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
thenByDescending arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ThenByDescending" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

thenByDescending_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IComparer.IComparer (objTy_2 t2  gTKey), NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IOrderedEnumerable.IOrderedEnumerable (objTy_3 t3  gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_2 t2  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTSource))
thenByDescending_1 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ThenByDescending" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1, arg2)

groupBy :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IGrouping.IGrouping (objTy_21 t21  gTKey gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  (NET.Object (objTy_21 t21  gTKey gTSource)))) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  (NET.Object (objTy_21 t21  gTKey gTSource))))
groupBy arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "GroupBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

groupBy_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_2 t2  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IGrouping.IGrouping (objTy_31 t31  gTKey gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_3 t3  (NET.Object (objTy_31 t31  gTKey gTSource)))) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_2 t2  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  (NET.Object (objTy_31 t31  gTKey gTSource))))
groupBy_1 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "GroupBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1, arg2)

groupBy_2 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.Type gTElement, NET.Result gTElement, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IGrouping.IGrouping (objTy_31 t31  gTKey gTElement), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_3 t3  (NET.Object (objTy_31 t31  gTKey gTElement)))) => ( gTSource -> IO  gTKey) -> ( gTSource -> IO  gTElement) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  (NET.Object (objTy_31 t31  gTKey gTElement))))
groupBy_2 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "GroupBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  [])  (arg0, arg1, arg2)

groupBy_3 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.Type gTElement, NET.Result gTElement, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_3 t3  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.IGrouping.IGrouping (objTy_41 t41  gTKey gTElement), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_4 t4  (NET.Object (objTy_41 t41  gTKey gTElement)))) => ( gTSource -> IO  gTKey) -> ( gTSource -> IO  gTElement) -> NET.Object (objTy_3 t3  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_4 t4  (NET.Object (objTy_41 t41  gTKey gTElement))))
groupBy_3 arg1 arg2 arg3 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "GroupBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  [])  (arg0, arg1, arg2, arg3)

groupBy_4 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.Arg gTKey, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_21 t21  gTSource), NET.Type (objTy_21 t21  gTSource), NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_3 t3  gTResult)) => ( gTSource -> IO  gTKey) -> ( ( gTKey, (NET.Object (objTy_21 t21  gTSource))) -> IO  gTResult) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTResult))
groupBy_4 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "GroupBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg2) $  [])  (arg0, arg1, arg2)

groupBy_5 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.Type gTElement, NET.Result gTElement, NET.Arg gTKey, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_31 t31  gTElement), NET.Type (objTy_31 t31  gTElement), NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_4 t4  gTResult)) => ( gTSource -> IO  gTKey) -> ( gTSource -> IO  gTElement) -> ( ( gTKey, (NET.Object (objTy_31 t31  gTElement))) -> IO  gTResult) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_4 t4  gTResult))
groupBy_5 arg1 arg2 arg3 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.System.Func.newFunc (\ a _obj -> arg3 a) >>= \ arg3 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "GroupBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  NET.tyNameCons ({-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg3) $  [])  (arg0, arg1, arg2, arg3)

groupBy_6 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.Arg gTKey, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_21 t21  gTSource), NET.Type (objTy_21 t21  gTSource), NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_3 t3  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_4 t4  gTResult)) => ( gTSource -> IO  gTKey) -> ( ( gTKey, (NET.Object (objTy_21 t21  gTSource))) -> IO  gTResult) -> NET.Object (objTy_3 t3  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_4 t4  gTResult))
groupBy_6 arg1 arg2 arg3 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "GroupBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg2) $  [])  (arg0, arg1, arg2, arg3)

groupBy_7 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.Type gTElement, NET.Result gTElement, NET.Arg gTKey, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_31 t31  gTElement), NET.Type (objTy_31 t31  gTElement), NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_4 t4  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_5 t5  gTResult)) => ( gTSource -> IO  gTKey) -> ( gTSource -> IO  gTElement) -> ( ( gTKey, (NET.Object (objTy_31 t31  gTElement))) -> IO  gTResult) -> NET.Object (objTy_4 t4  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_5 t5  gTResult))
groupBy_7 arg1 arg2 arg3 arg4 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.System.Func.newFunc (\ a _obj -> arg3 a) >>= \ arg3 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "GroupBy" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  NET.tyNameCons ({-0-}NET.t22{-3 3-} $ NET.t22 $ NET.t11 arg3) $  [])  (arg0, arg1, arg2, arg3, arg4)

concat :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => NET.Object (objTy_1 t1  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
concat arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Concat" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

distinct :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource)) => NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_1 t1  gTSource))
distinct arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Distinct" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

distinct_1 :: (NET.Type gTSource, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_1 t1  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => NET.Object (objTy_1 t1  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
distinct_1 arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Distinct" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

union :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => NET.Object (objTy_1 t1  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
union arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Union" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

union_1 :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource), NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_2 t2  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_3 t3  gTSource)) => NET.Object (objTy_1 t1  gTSource) -> NET.Object (objTy_2 t2  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTSource))
union_1 arg1 arg2 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Union" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1, arg2)

intersect :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => NET.Object (objTy_1 t1  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
intersect arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Intersect" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

intersect_1 :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource), NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_2 t2  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_3 t3  gTSource)) => NET.Object (objTy_1 t1  gTSource) -> NET.Object (objTy_2 t2  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTSource))
intersect_1 arg1 arg2 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Intersect" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1, arg2)

except :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => NET.Object (objTy_1 t1  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
except arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Except" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

except_1 :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource), NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_2 t2  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_3 t3  gTSource)) => NET.Object (objTy_1 t1  gTSource) -> NET.Object (objTy_2 t2  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTSource))
except_1 arg1 arg2 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Except" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1, arg2)

reverse :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource)) => NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_1 t1  gTSource))
reverse arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Reverse" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

sequenceEqual :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => NET.Object (objTy_1 t1  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (Bool)
sequenceEqual arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "SequenceEqual" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

sequenceEqual_1 :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource), NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_2 t2  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => NET.Object (objTy_1 t1  gTSource) -> NET.Object (objTy_2 t2  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (Bool)
sequenceEqual_1 arg1 arg2 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "SequenceEqual" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1, arg2)

asEnumerable :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource)) => NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_1 t1  gTSource))
asEnumerable arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "AsEnumerable" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

toArray :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Arg gTSource) => NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Array.Array (gTSource))
toArray arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "ToArray" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

toList :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Collections.Generic.List.List a1 gTSource)
toList arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "ToList" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

toDictionary :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Collections.Generic.Dictionary.Dictionary a2 gTKey gTSource)
toDictionary arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ToDictionary" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

toDictionary_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_2 t2  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_2 t2  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Collections.Generic.Dictionary.Dictionary a3 gTKey gTSource)
toDictionary_1 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ToDictionary" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1, arg2)

toDictionary_2 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.Type gTElement, NET.Result gTElement, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  gTKey) -> ( gTSource -> IO  gTElement) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Collections.Generic.Dictionary.Dictionary a3 gTKey gTElement)
toDictionary_2 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ToDictionary" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  [])  (arg0, arg1, arg2)

toDictionary_3 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.Type gTElement, NET.Result gTElement, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_3 t3  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  gTKey) -> ( gTSource -> IO  gTElement) -> NET.Object (objTy_3 t3  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Collections.Generic.Dictionary.Dictionary a4 gTKey gTElement)
toDictionary_3 arg1 arg2 arg3 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ToDictionary" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  [])  (arg0, arg1, arg2, arg3)

toLookup :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.ILookup.ILookup (objTy_2 t2  gTKey gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTKey gTSource))
toLookup arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ToLookup" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

toLookup_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_2 t2  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.ILookup.ILookup (objTy_3 t3  gTKey gTSource)) => ( gTSource -> IO  gTKey) -> NET.Object (objTy_2 t2  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTKey gTSource))
toLookup_1 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ToLookup" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1, arg2)

toLookup_2 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.Type gTElement, NET.Result gTElement, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.ILookup.ILookup (objTy_3 t3  gTKey gTElement)) => ( gTSource -> IO  gTKey) -> ( gTSource -> IO  gTElement) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_3 t3  gTKey gTElement))
toLookup_2 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ToLookup" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  [])  (arg0, arg1, arg2)

toLookup_3 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTKey, NET.Result gTKey, NET.Type gTElement, NET.Result gTElement, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_3 t3  gTKey), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Linq.ILookup.ILookup (objTy_4 t4  gTKey gTElement)) => ( gTSource -> IO  gTKey) -> ( gTSource -> IO  gTElement) -> NET.Object (objTy_3 t3  gTKey) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_4 t4  gTKey gTElement))
toLookup_3 arg1 arg2 arg3 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "ToLookup" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg2) $  [])  (arg0, arg1, arg2, arg3)

defaultIfEmpty :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTSource)) => NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_1 t1  gTSource))
defaultIfEmpty arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "DefaultIfEmpty" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

defaultIfEmpty_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTSource)) => gTSource -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.Object (objTy_2 t2  gTSource))
defaultIfEmpty_1 arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "DefaultIfEmpty" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

ofType :: (NET.System.Collections.IEnumerable.IEnumerable a0, NET.Type gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTResult)) => NET.Object (objTy0 a0)-> IO (NET.Object (objTy_1 t1  gTResult))
ofType arg0 = let res = NET.invokeGenericStatic "System.Linq.Enumerable" "OfType" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11  $ NET.t11 res) $  [])  (arg0) in res

cast :: (NET.System.Collections.IEnumerable.IEnumerable a0, NET.Type gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTResult)) => NET.Object (objTy0 a0)-> IO (NET.Object (objTy_1 t1  gTResult))
cast arg0 = let res = NET.invokeGenericStatic "System.Linq.Enumerable" "Cast" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11  $ NET.t11 res) $  [])  (arg0) in res

first :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
first arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "First" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

first_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
first_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "First" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

firstOrDefault :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
firstOrDefault arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "FirstOrDefault" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

firstOrDefault_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
firstOrDefault_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "FirstOrDefault" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

last :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
last arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Last" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

last_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
last_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Last" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

lastOrDefault :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
lastOrDefault arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "LastOrDefault" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

lastOrDefault_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
lastOrDefault_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "LastOrDefault" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

single :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
single arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Single" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

single_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
single_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Single" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

singleOrDefault :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
singleOrDefault arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "SingleOrDefault" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

singleOrDefault_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
singleOrDefault_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "SingleOrDefault" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

elementAt :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => Data.Int.Int32 -> NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
elementAt arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "ElementAt" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

elementAtOrDefault :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => Data.Int.Int32 -> NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
elementAtOrDefault arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "ElementAtOrDefault" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

range :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  Data.Int.Int32)) => Data.Int.Int32 -> Data.Int.Int32 -> IO (NET.Object (objTy_2 t2  Data.Int.Int32))
range arg0 arg1 = NET.invokeStatic "System.Linq.Enumerable" "Range"  (arg0, arg1)

repeat :: (NET.Type gTResult, NET.Arg gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_2 t2  gTResult)) => gTResult -> Data.Int.Int32 -> IO (NET.Object (objTy_2 t2  gTResult))
repeat arg0 arg1 = let res = NET.invokeGenericStatic "System.Linq.Enumerable" "Repeat" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11  $ NET.t11 res) $  [])  (arg0, arg1) in res

empty :: (NET.Type gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTResult)) => IO (NET.Object (objTy_0 t0  gTResult))
empty = let res = NET.invokeGenericStatic "System.Linq.Enumerable" "Empty" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11  $ NET.t11 res) $  [])  ()  in res

any :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => NET.Object (objTy_0 t0  gTSource)-> IO (Bool)
any arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Any" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

any_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (Bool)
any_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Any" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

all :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (Bool)
all arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "All" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

count :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => NET.Object (objTy_0 t0  gTSource)-> IO (Data.Int.Int32)
count arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Count" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

count_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (Data.Int.Int32)
count_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Count" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

longCount :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => NET.Object (objTy_0 t0  gTSource)-> IO (Data.Int.Int64)
longCount arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "LongCount" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

longCount_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Bool) -> NET.Object (objTy_0 t0  gTSource)-> IO (Data.Int.Int64)
longCount_1 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "LongCount" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

contains :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => gTSource -> NET.Object (objTy_0 t0  gTSource)-> IO (Bool)
contains arg1 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Contains" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

contains_1 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_2 t2  gTSource), NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => gTSource -> NET.Object (objTy_2 t2  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (Bool)
contains_1 arg1 arg2 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Contains" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1, arg2)

aggregate :: (NET.Type gTSource, NET.Arg gTSource, NET.Result gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( ( gTSource, gTSource) -> IO  gTSource) -> NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
aggregate arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Aggregate" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

aggregate_1 :: (NET.Type gTAccumulate, NET.Arg gTAccumulate, NET.Type gTSource, NET.Arg gTSource, NET.Result gTAccumulate, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => gTAccumulate -> ( ( gTAccumulate, gTSource) -> IO  gTAccumulate) -> NET.Object (objTy_0 t0  gTSource)-> IO (gTAccumulate)
aggregate_1 arg1 arg2 arg0 = NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Aggregate" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ( {-a-}NET.t22 $ NET.t11 arg2) $  [])  (arg0, arg1, arg2)

aggregate_2 :: (NET.Type gTAccumulate, NET.Arg gTAccumulate, NET.Type gTSource, NET.Arg gTSource, NET.Result gTAccumulate, NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => gTAccumulate -> ( ( gTAccumulate, gTSource) -> IO  gTAccumulate) -> ( gTAccumulate -> IO  gTResult) -> NET.Object (objTy_0 t0  gTSource)-> IO (gTResult)
aggregate_2 arg1 arg2 arg3 arg0 = NET.System.Func.newFunc (\ a _obj -> arg2 a) >>= \ arg2 ->  NET.System.Func.newFunc (\ a _obj -> arg3 a) >>= \ arg3 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Aggregate" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ( {-a-}NET.t22 $ NET.t11 arg2) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg3) $  [])  (arg0, arg1, arg2, arg3)

sum :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Data.Int.Int32)) => NET.Object (objTy_0 t0  Data.Int.Int32)-> IO (Data.Int.Int32)
sum arg0 = NET.invokeStatic "System.Linq.Enumerable" "Sum"  (arg0)

sum_1 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int32))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int32))-> IO (NET.System.Nullable.Nullable a1 Data.Int.Int32)
sum_1 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Sum"  (arg0)

sum_2 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Data.Int.Int64)) => NET.Object (objTy_0 t0  Data.Int.Int64)-> IO (Data.Int.Int64)
sum_2 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Sum"  (arg0)

sum_3 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int64))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int64))-> IO (NET.System.Nullable.Nullable a1 Data.Int.Int64)
sum_3 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Sum"  (arg0)

sum_4 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Float)) => NET.Object (objTy_0 t0  Float)-> IO (Float)
sum_4 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Sum"  (arg0)

sum_5 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Float))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Float))-> IO (NET.System.Nullable.Nullable a1 Float)
sum_5 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Sum"  (arg0)

sum_6 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Double)) => NET.Object (objTy_0 t0  Double)-> IO (Double)
sum_6 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Sum"  (arg0)

sum_7 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Double))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Double))-> IO (NET.System.Nullable.Nullable a1 Double)
sum_7 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Sum"  (arg0)

sum_8 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Decimal.Decimal a1))) => NET.Object (objTy_0 t0  (NET.System.Decimal.Decimal a1))-> IO (NET.System.Decimal.Decimal a1)
sum_8 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Sum"  (arg0)

sum_9 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11)))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11)))-> IO (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11))
sum_9 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Sum"  (arg0)

sum_10 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Data.Int.Int32) -> NET.Object (objTy_0 t0  gTSource)-> IO (Data.Int.Int32)
sum_10 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Sum" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

sum_11 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Data.Int.Int32)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Data.Int.Int32)
sum_11 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Sum" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

sum_12 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Data.Int.Int64) -> NET.Object (objTy_0 t0  gTSource)-> IO (Data.Int.Int64)
sum_12 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Sum" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

sum_13 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Data.Int.Int64)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Data.Int.Int64)
sum_13 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Sum" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

sum_14 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Float) -> NET.Object (objTy_0 t0  gTSource)-> IO (Float)
sum_14 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Sum" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

sum_15 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Float)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Float)
sum_15 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Sum" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

sum_16 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Double) -> NET.Object (objTy_0 t0  gTSource)-> IO (Double)
sum_16 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Sum" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

sum_17 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Double)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Double)
sum_17 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Sum" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

sum_18 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Decimal.Decimal a11)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Decimal.Decimal a2)
sum_18 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Sum" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

sum_19 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 (NET.System.Decimal.Decimal a111))) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 (NET.System.Decimal.Decimal a21))
sum_19 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Sum" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

min :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Data.Int.Int32)) => NET.Object (objTy_0 t0  Data.Int.Int32)-> IO (Data.Int.Int32)
min arg0 = NET.invokeStatic "System.Linq.Enumerable" "Min"  (arg0)

min_1 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int32))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int32))-> IO (NET.System.Nullable.Nullable a1 Data.Int.Int32)
min_1 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Min"  (arg0)

min_2 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Data.Int.Int64)) => NET.Object (objTy_0 t0  Data.Int.Int64)-> IO (Data.Int.Int64)
min_2 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Min"  (arg0)

min_3 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int64))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int64))-> IO (NET.System.Nullable.Nullable a1 Data.Int.Int64)
min_3 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Min"  (arg0)

min_4 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Float)) => NET.Object (objTy_0 t0  Float)-> IO (Float)
min_4 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Min"  (arg0)

min_5 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Float))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Float))-> IO (NET.System.Nullable.Nullable a1 Float)
min_5 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Min"  (arg0)

min_6 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Double)) => NET.Object (objTy_0 t0  Double)-> IO (Double)
min_6 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Min"  (arg0)

min_7 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Double))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Double))-> IO (NET.System.Nullable.Nullable a1 Double)
min_7 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Min"  (arg0)

min_8 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Decimal.Decimal a1))) => NET.Object (objTy_0 t0  (NET.System.Decimal.Decimal a1))-> IO (NET.System.Decimal.Decimal a1)
min_8 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Min"  (arg0)

min_9 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11)))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11)))-> IO (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11))
min_9 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Min"  (arg0)

min_10 :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
min_10 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

min_11 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Data.Int.Int32) -> NET.Object (objTy_0 t0  gTSource)-> IO (Data.Int.Int32)
min_11 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

min_12 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Data.Int.Int32)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Data.Int.Int32)
min_12 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

min_13 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Data.Int.Int64) -> NET.Object (objTy_0 t0  gTSource)-> IO (Data.Int.Int64)
min_13 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

min_14 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Data.Int.Int64)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Data.Int.Int64)
min_14 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

min_15 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Float) -> NET.Object (objTy_0 t0  gTSource)-> IO (Float)
min_15 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

min_16 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Float)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Float)
min_16 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

min_17 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Double) -> NET.Object (objTy_0 t0  gTSource)-> IO (Double)
min_17 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

min_18 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Double)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Double)
min_18 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

min_19 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Decimal.Decimal a11)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Decimal.Decimal a2)
min_19 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

min_20 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 (NET.System.Decimal.Decimal a111))) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 (NET.System.Decimal.Decimal a21))
min_20 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

min_21 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  gTResult) -> NET.Object (objTy_0 t0  gTSource)-> IO (gTResult)
min_21 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Min" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

max :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Data.Int.Int32)) => NET.Object (objTy_0 t0  Data.Int.Int32)-> IO (Data.Int.Int32)
max arg0 = NET.invokeStatic "System.Linq.Enumerable" "Max"  (arg0)

max_1 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int32))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int32))-> IO (NET.System.Nullable.Nullable a1 Data.Int.Int32)
max_1 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Max"  (arg0)

max_2 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Data.Int.Int64)) => NET.Object (objTy_0 t0  Data.Int.Int64)-> IO (Data.Int.Int64)
max_2 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Max"  (arg0)

max_3 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int64))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int64))-> IO (NET.System.Nullable.Nullable a1 Data.Int.Int64)
max_3 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Max"  (arg0)

max_4 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Double)) => NET.Object (objTy_0 t0  Double)-> IO (Double)
max_4 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Max"  (arg0)

max_5 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Double))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Double))-> IO (NET.System.Nullable.Nullable a1 Double)
max_5 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Max"  (arg0)

max_6 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Float)) => NET.Object (objTy_0 t0  Float)-> IO (Float)
max_6 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Max"  (arg0)

max_7 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Float))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Float))-> IO (NET.System.Nullable.Nullable a1 Float)
max_7 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Max"  (arg0)

max_8 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Decimal.Decimal a1))) => NET.Object (objTy_0 t0  (NET.System.Decimal.Decimal a1))-> IO (NET.System.Decimal.Decimal a1)
max_8 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Max"  (arg0)

max_9 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11)))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11)))-> IO (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11))
max_9 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Max"  (arg0)

max_10 :: (NET.Type gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource), NET.Result gTSource) => NET.Object (objTy_0 t0  gTSource)-> IO (gTSource)
max_10 arg0 = NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0)

max_11 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Data.Int.Int32) -> NET.Object (objTy_0 t0  gTSource)-> IO (Data.Int.Int32)
max_11 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

max_12 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Data.Int.Int32)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Data.Int.Int32)
max_12 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

max_13 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Data.Int.Int64) -> NET.Object (objTy_0 t0  gTSource)-> IO (Data.Int.Int64)
max_13 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

max_14 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Data.Int.Int64)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Data.Int.Int64)
max_14 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

max_15 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Float) -> NET.Object (objTy_0 t0  gTSource)-> IO (Float)
max_15 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

max_16 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Float)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Float)
max_16 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

max_17 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Double) -> NET.Object (objTy_0 t0  gTSource)-> IO (Double)
max_17 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

max_18 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Double)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Double)
max_18 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

max_19 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Decimal.Decimal a11)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Decimal.Decimal a2)
max_19 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

max_20 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 (NET.System.Decimal.Decimal a111))) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 (NET.System.Decimal.Decimal a21))
max_20 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

max_21 :: (NET.Type gTSource, NET.Arg gTSource, NET.Type gTResult, NET.Result gTResult, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  gTResult) -> NET.Object (objTy_0 t0  gTSource)-> IO (gTResult)
max_21 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Max" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  NET.tyNameCons ({-0-}NET.t22{-2 2-} $ NET.t22 $ NET.t11 arg1) $  [])  (arg0, arg1)

average :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Data.Int.Int32)) => NET.Object (objTy_0 t0  Data.Int.Int32)-> IO (Double)
average arg0 = NET.invokeStatic "System.Linq.Enumerable" "Average"  (arg0)

average_1 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int32))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int32))-> IO (NET.System.Nullable.Nullable a1 Double)
average_1 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Average"  (arg0)

average_2 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Data.Int.Int64)) => NET.Object (objTy_0 t0  Data.Int.Int64)-> IO (Double)
average_2 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Average"  (arg0)

average_3 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int64))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Data.Int.Int64))-> IO (NET.System.Nullable.Nullable a1 Double)
average_3 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Average"  (arg0)

average_4 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Float)) => NET.Object (objTy_0 t0  Float)-> IO (Float)
average_4 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Average"  (arg0)

average_5 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Float))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Float))-> IO (NET.System.Nullable.Nullable a1 Float)
average_5 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Average"  (arg0)

average_6 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  Double)) => NET.Object (objTy_0 t0  Double)-> IO (Double)
average_6 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Average"  (arg0)

average_7 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 Double))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 Double))-> IO (NET.System.Nullable.Nullable a1 Double)
average_7 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Average"  (arg0)

average_8 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Decimal.Decimal a1))) => NET.Object (objTy_0 t0  (NET.System.Decimal.Decimal a1))-> IO (NET.System.Decimal.Decimal a1)
average_8 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Average"  (arg0)

average_9 :: (NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11)))) => NET.Object (objTy_0 t0  (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11)))-> IO (NET.System.Nullable.Nullable a1 (NET.System.Decimal.Decimal a11))
average_9 arg0 = NET.invokeStatic "System.Linq.Enumerable" "Average"  (arg0)

average_10 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Data.Int.Int32) -> NET.Object (objTy_0 t0  gTSource)-> IO (Double)
average_10 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Average" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

average_11 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Data.Int.Int32)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Double)
average_11 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Average" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

average_12 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Data.Int.Int64) -> NET.Object (objTy_0 t0  gTSource)-> IO (Double)
average_12 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Average" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

average_13 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Data.Int.Int64)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Double)
average_13 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Average" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

average_14 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Float) -> NET.Object (objTy_0 t0  gTSource)-> IO (Float)
average_14 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Average" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

average_15 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Float)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Float)
average_15 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Average" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

average_16 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  Double) -> NET.Object (objTy_0 t0  gTSource)-> IO (Double)
average_16 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Average" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

average_17 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 Double)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 Double)
average_17 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Average" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

average_18 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Decimal.Decimal a11)) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Decimal.Decimal a2)
average_18 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Average" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)

average_19 :: (NET.Type gTSource, NET.Arg gTSource, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gTSource)) => ( gTSource -> IO  (NET.System.Nullable.Nullable a11 (NET.System.Decimal.Decimal a111))) -> NET.Object (objTy_0 t0  gTSource)-> IO (NET.System.Nullable.Nullable a2 (NET.System.Decimal.Decimal a21))
average_19 arg1 arg0 = NET.System.Func.newFunc (\ a _obj -> arg1 a) >>= \ arg1 ->  NET.invokeGenericStatic "System.Linq.Enumerable" "Average" ( NET.tyMethSplit $  NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 arg0) $  [])  (arg0, arg1)


