{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.UriComponents.Type ( module NET.System.UriComponents.Type ) where

import qualified NET
import qualified NET.System.Type.Type as NET.System.Type
import qualified NET.System.Enum.Type as NET.System.Enum
import qualified NET.System.IComparable.Type as NET.System.IComparable
import qualified NET.System.IFormattable.Type as NET.System.IFormattable
import qualified NET.System.IConvertible.Type as NET.System.IConvertible

instance NET.System.IComparable.IComparable (UriComponentsTy) where
  instanceName_IComparable _ = "NET.System.UriComponents.UriComponents"

instance NET.System.IFormattable.IFormattable (UriComponentsTy) where
  instanceName_IFormattable _ = "NET.System.UriComponents.UriComponents"

instance NET.System.IConvertible.IConvertible (UriComponentsTy) where
  instanceName_IConvertible _ = "NET.System.UriComponents.UriComponents"

type UriComponents a = Int
data UriComponentsTy
 = Scheme
 | UserInfo
 | Host
 | Port
 | Path
 | Query
 | Fragment
 | StrongPort
 | KeepDelimiter
 | SerializationInfoString
 | AbsoluteUri
 | HostAndPort
 | StrongAuthority
 | SchemeAndServer
 | HttpRequestUrl
 | PathAndQuery
  deriving ( Enum, Show, Read )
toUriComponents :: UriComponentsTy -> UriComponents ()
toUriComponents tag = fromEnum tag

fromUriComponents :: UriComponents () -> UriComponentsTy
fromUriComponents obj = toEnum obj

