{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Collections.Generic.Dictionary ( module NET.System.Collections.Generic.Dictionary ) where

import qualified NET
import NET.System.Collections.Generic.Dictionary.Type as NET.System.Collections.Generic.Dictionary
import qualified NET.System.Collections.Generic.IEqualityComparer.Type as NET.System.Collections.Generic.IEqualityComparer
import qualified Data.Int
import qualified NET.System.Collections.Generic.Dictionary.ValueCollection.Type as NET.System.Collections.Generic.Dictionary.ValueCollection
import qualified NET.System.Collections.Generic.Dictionary.Enumerator.Type as NET.System.Collections.Generic.Dictionary.Enumerator
import qualified NET.System.Runtime.Serialization.SerializationInfo.Type as NET.System.Runtime.Serialization.SerializationInfo
import qualified NET.System.Runtime.Serialization.StreamingContext.Type as NET.System.Runtime.Serialization.StreamingContext
import qualified NET.System.Collections.Generic.Dictionary.KeyCollection.Type as NET.System.Collections.Generic.Dictionary.KeyCollection
import qualified NET.System.Object

get_Comparer :: (NET.Type gTKey, NET.Type gTValue, NET.System.Collections.Generic.IEqualityComparer.IEqualityComparer (objTy_0 t0  gTKey)) => Dictionary obj  gTKey gTValue -> IO (NET.Object (objTy_0 t0  gTKey))
get_Comparer obj = NET.invokeGeneric "get_Comparer" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  NET.tyMethSplit $  [])  ()  obj

get_Count :: (NET.Type gTKey, NET.Type gTValue) => Dictionary obj  gTKey gTValue -> IO (Data.Int.Int32)
get_Count obj = NET.invokeGeneric "get_Count" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  ()  obj

get_Values :: (NET.Type gTKey, NET.Type gTValue) => Dictionary obj  gTKey gTValue -> IO (NET.System.Collections.Generic.Dictionary.ValueCollection.ValueCollection a0 gTKey gTValue)
get_Values obj = NET.invokeGeneric "get_Values" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  NET.tyMethSplit $  [])  ()  obj

add :: (NET.Type gTKey, NET.Type gTValue, NET.Arg gTKey, NET.Arg gTValue) => gTKey -> gTValue -> Dictionary obj  gTKey gTValue -> IO (())
add arg0 arg1 obj = NET.invokeGeneric "Add" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  (arg0, arg1) obj

clear :: (NET.Type gTKey, NET.Type gTValue) => Dictionary obj  gTKey gTValue -> IO (())
clear obj = NET.invokeGeneric "Clear" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  ()  obj

containsKey :: (NET.Type gTKey, NET.Type gTValue, NET.Arg gTKey) => gTKey -> Dictionary obj  gTKey gTValue -> IO (Bool)
containsKey arg0 obj = NET.invokeGeneric "ContainsKey" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  (arg0) obj

containsValue :: (NET.Type gTKey, NET.Type gTValue, NET.Arg gTValue) => gTValue -> Dictionary obj  gTKey gTValue -> IO (Bool)
containsValue arg0 obj = NET.invokeGeneric "ContainsValue" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  (arg0) obj

getEnumerator :: (NET.Type gTKey, NET.Type gTValue) => Dictionary obj  gTKey gTValue -> IO (NET.System.Collections.Generic.Dictionary.Enumerator.Enumerator a0 gTKey gTValue)
getEnumerator obj = NET.invokeGeneric "GetEnumerator" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  NET.tyMethSplit $  [])  ()  obj

getObjectData :: (NET.Type gTKey, NET.Type gTValue) => NET.System.Runtime.Serialization.SerializationInfo.SerializationInfo a0 -> NET.System.Runtime.Serialization.StreamingContext.StreamingContext a1 -> Dictionary obj  gTKey gTValue -> IO (())
getObjectData arg0 arg1 obj = NET.invokeGeneric "GetObjectData" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  (arg0, arg1) obj

onDeserialization :: (NET.Type gTKey, NET.Type gTValue) => NET.Object (objTy0 a0) -> Dictionary obj  gTKey gTValue -> IO (())
onDeserialization arg0 obj = NET.invokeGeneric "OnDeserialization" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  (arg0) obj

remove :: (NET.Type gTKey, NET.Type gTValue, NET.Arg gTKey) => gTKey -> Dictionary obj  gTKey gTValue -> IO (Bool)
remove arg0 obj = NET.invokeGeneric "Remove" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  (arg0) obj

tryGetValue :: (NET.Type gTKey, NET.Type gTValue, NET.Arg gTKey, NET.Arg gTValue) => gTKey -> gTValue -> Dictionary obj  gTKey gTValue -> IO (Bool)
tryGetValue arg0 arg1 obj = NET.invokeGeneric "TryGetValue" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  (arg0, arg1) obj

get_Keys :: (NET.Type gTKey, NET.Type gTValue) => Dictionary obj  gTKey gTValue -> IO (NET.System.Collections.Generic.Dictionary.KeyCollection.KeyCollection a0 gTKey gTValue)
get_Keys obj = NET.invokeGeneric "get_Keys" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  NET.tyMethSplit $  [])  ()  obj

get_Item :: (NET.Type gTKey, NET.Type gTValue, NET.Arg gTKey, NET.Result gTValue) => gTKey -> Dictionary obj  gTKey gTValue -> IO (gTValue)
get_Item arg0 obj = NET.invokeGeneric "get_Item" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  (arg0) obj

set_Item :: (NET.Type gTKey, NET.Type gTValue, NET.Arg gTKey, NET.Arg gTValue) => gTKey -> gTValue -> Dictionary obj  gTKey gTValue -> IO (())
set_Item arg0 arg1 obj = NET.invokeGeneric "set_Item" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  (arg0, arg1) obj


