{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Collections.Generic.KeyValuePair ( module NET.System.Collections.Generic.KeyValuePair ) where

import qualified NET
import NET.System.Collections.Generic.KeyValuePair.Type as NET.System.Collections.Generic.KeyValuePair
import qualified NET.System.ValueType.Type as NET.System.ValueType

get_Key :: (NET.Type gTKey, NET.Type gTValue, NET.Result gTKey) => KeyValuePair obj  gTKey gTValue -> IO (gTKey)
get_Key obj = NET.invokeGeneric "get_Key" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  ()  obj

get_Value :: (NET.Type gTKey, NET.Type gTValue, NET.Result gTValue) => KeyValuePair obj  gTKey gTValue -> IO (gTValue)
get_Value obj = NET.invokeGeneric "get_Value" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  ()  obj

toString :: (NET.Type gTKey, NET.Type gTValue) => KeyValuePair obj  gTKey gTValue -> IO (String)
toString obj = NET.invokeGeneric "ToString" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  ()  obj


