{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Collections.Generic.List ( module NET.System.Collections.Generic.List ) where

import qualified NET
import NET.System.Collections.Generic.List.Type as NET.System.Collections.Generic.List
import qualified NET.System.Collections.Generic.IEnumerable.Type as NET.System.Collections.Generic.IEnumerable
import qualified NET.System.Collections.ObjectModel.ReadOnlyCollection.Type as NET.System.Collections.ObjectModel.ReadOnlyCollection
import qualified Data.Int
import qualified NET.System.Collections.Generic.IComparer.Type as NET.System.Collections.Generic.IComparer
import qualified NET.System.Array
import qualified NET.System.Predicate
import qualified NET.System.Collections.Generic.List.Type as NET.System.Collections.Generic.List
import qualified NET.System.Action
import qualified NET.System.Collections.Generic.List.Enumerator.Type as NET.System.Collections.Generic.List.Enumerator
import qualified NET.System.Comparison.Type as NET.System.Comparison
import qualified NET.System.Converter.Type as NET.System.Converter
import qualified NET.System.Object

addRange :: (NET.Type gT, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_0 t0  gT)) => NET.Object (objTy_0 t0  gT) -> List obj  gT -> IO (())
addRange arg0 obj = NET.invokeGeneric "AddRange" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

asReadOnly :: (NET.Type gT) => List obj  gT -> IO (NET.System.Collections.ObjectModel.ReadOnlyCollection.ReadOnlyCollection a0 gT)
asReadOnly obj = NET.invokeGeneric "AsReadOnly" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  NET.tyMethSplit $  [])  ()  obj

binarySearch :: (NET.Type gT, NET.Arg gT, NET.System.Collections.Generic.IComparer.IComparer (objTy_3 t3  gT)) => Data.Int.Int32 -> Data.Int.Int32 -> gT -> NET.Object (objTy_3 t3  gT) -> List obj  gT -> IO (Data.Int.Int32)
binarySearch arg0 arg1 arg2 arg3 obj = NET.invokeGeneric "BinarySearch" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1, arg2, arg3) obj

binarySearch_1 :: (NET.Type gT, NET.Arg gT) => gT -> List obj  gT -> IO (Data.Int.Int32)
binarySearch_1 arg0 obj = NET.invokeGeneric "BinarySearch" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

binarySearch_2 :: (NET.Type gT, NET.Arg gT, NET.System.Collections.Generic.IComparer.IComparer (objTy_1 t1  gT)) => gT -> NET.Object (objTy_1 t1  gT) -> List obj  gT -> IO (Data.Int.Int32)
binarySearch_2 arg0 arg1 obj = NET.invokeGeneric "BinarySearch" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

clear :: (NET.Type gT) => List obj  gT -> IO (())
clear obj = NET.invokeGeneric "Clear" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  ()  obj

contains :: (NET.Type gT, NET.Arg gT) => gT -> List obj  gT -> IO (Bool)
contains arg0 obj = NET.invokeGeneric "Contains" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

copyTo :: (NET.Type gT, NET.Arg gT) => NET.System.Array.Array (gT) -> List obj  gT -> IO (())
copyTo arg0 obj = NET.invokeGeneric "CopyTo" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

copyTo_1 :: (NET.Type gT, NET.Arg gT) => Data.Int.Int32 -> NET.System.Array.Array (gT) -> Data.Int.Int32 -> Data.Int.Int32 -> List obj  gT -> IO (())
copyTo_1 arg0 arg1 arg2 arg3 obj = NET.invokeGeneric "CopyTo" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1, arg2, arg3) obj

copyTo_2 :: (NET.Type gT, NET.Arg gT) => NET.System.Array.Array (gT) -> Data.Int.Int32 -> List obj  gT -> IO (())
copyTo_2 arg0 arg1 obj = NET.invokeGeneric "CopyTo" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

exists :: (NET.Type gT) => NET.System.Predicate.Predicate a0 gT -> List obj  gT -> IO (Bool)
exists arg0 obj = NET.invokeGeneric "Exists" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

find :: (NET.Type gT, NET.Result gT) => NET.System.Predicate.Predicate a0 gT -> List obj  gT -> IO (gT)
find arg0 obj = NET.invokeGeneric "Find" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

findAll :: (NET.Type gT) => NET.System.Predicate.Predicate a0 gT -> List obj  gT -> IO (NET.System.Collections.Generic.List.List a1 gT)
findAll arg0 obj = NET.invokeGeneric "FindAll" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  NET.tyMethSplit $  [])  (arg0) obj

findIndex :: (NET.Type gT) => NET.System.Predicate.Predicate a0 gT -> List obj  gT -> IO (Data.Int.Int32)
findIndex arg0 obj = NET.invokeGeneric "FindIndex" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

findIndex_1 :: (NET.Type gT) => Data.Int.Int32 -> NET.System.Predicate.Predicate a1 gT -> List obj  gT -> IO (Data.Int.Int32)
findIndex_1 arg0 arg1 obj = NET.invokeGeneric "FindIndex" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

findIndex_2 :: (NET.Type gT) => Data.Int.Int32 -> Data.Int.Int32 -> NET.System.Predicate.Predicate a2 gT -> List obj  gT -> IO (Data.Int.Int32)
findIndex_2 arg0 arg1 arg2 obj = NET.invokeGeneric "FindIndex" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1, arg2) obj

findLast :: (NET.Type gT, NET.Result gT) => NET.System.Predicate.Predicate a0 gT -> List obj  gT -> IO (gT)
findLast arg0 obj = NET.invokeGeneric "FindLast" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

findLastIndex :: (NET.Type gT) => NET.System.Predicate.Predicate a0 gT -> List obj  gT -> IO (Data.Int.Int32)
findLastIndex arg0 obj = NET.invokeGeneric "FindLastIndex" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

findLastIndex_1 :: (NET.Type gT) => Data.Int.Int32 -> NET.System.Predicate.Predicate a1 gT -> List obj  gT -> IO (Data.Int.Int32)
findLastIndex_1 arg0 arg1 obj = NET.invokeGeneric "FindLastIndex" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

findLastIndex_2 :: (NET.Type gT) => Data.Int.Int32 -> Data.Int.Int32 -> NET.System.Predicate.Predicate a2 gT -> List obj  gT -> IO (Data.Int.Int32)
findLastIndex_2 arg0 arg1 arg2 obj = NET.invokeGeneric "FindLastIndex" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1, arg2) obj

forEach :: (NET.Type gT) => NET.System.Action.Action a0 gT -> List obj  gT -> IO (())
forEach arg0 obj = NET.invokeGeneric "ForEach" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

getEnumerator :: (NET.Type gT) => List obj  gT -> IO (NET.System.Collections.Generic.List.Enumerator.Enumerator a0 gT)
getEnumerator obj = NET.invokeGeneric "GetEnumerator" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  NET.tyMethSplit $  [])  ()  obj

getRange :: (NET.Type gT) => Data.Int.Int32 -> Data.Int.Int32 -> List obj  gT -> IO (NET.System.Collections.Generic.List.List a2 gT)
getRange arg0 arg1 obj = NET.invokeGeneric "GetRange" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  NET.tyMethSplit $  [])  (arg0, arg1) obj

indexOf :: (NET.Type gT, NET.Arg gT) => gT -> List obj  gT -> IO (Data.Int.Int32)
indexOf arg0 obj = NET.invokeGeneric "IndexOf" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

indexOf_1 :: (NET.Type gT, NET.Arg gT) => gT -> Data.Int.Int32 -> List obj  gT -> IO (Data.Int.Int32)
indexOf_1 arg0 arg1 obj = NET.invokeGeneric "IndexOf" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

indexOf_2 :: (NET.Type gT, NET.Arg gT) => gT -> Data.Int.Int32 -> Data.Int.Int32 -> List obj  gT -> IO (Data.Int.Int32)
indexOf_2 arg0 arg1 arg2 obj = NET.invokeGeneric "IndexOf" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1, arg2) obj

insert :: (NET.Type gT, NET.Arg gT) => Data.Int.Int32 -> gT -> List obj  gT -> IO (())
insert arg0 arg1 obj = NET.invokeGeneric "Insert" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

insertRange :: (NET.Type gT, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gT)) => Data.Int.Int32 -> NET.Object (objTy_1 t1  gT) -> List obj  gT -> IO (())
insertRange arg0 arg1 obj = NET.invokeGeneric "InsertRange" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

lastIndexOf :: (NET.Type gT, NET.Arg gT) => gT -> List obj  gT -> IO (Data.Int.Int32)
lastIndexOf arg0 obj = NET.invokeGeneric "LastIndexOf" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

lastIndexOf_1 :: (NET.Type gT, NET.Arg gT) => gT -> Data.Int.Int32 -> List obj  gT -> IO (Data.Int.Int32)
lastIndexOf_1 arg0 arg1 obj = NET.invokeGeneric "LastIndexOf" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

lastIndexOf_2 :: (NET.Type gT, NET.Arg gT) => gT -> Data.Int.Int32 -> Data.Int.Int32 -> List obj  gT -> IO (Data.Int.Int32)
lastIndexOf_2 arg0 arg1 arg2 obj = NET.invokeGeneric "LastIndexOf" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1, arg2) obj

remove :: (NET.Type gT, NET.Arg gT) => gT -> List obj  gT -> IO (Bool)
remove arg0 obj = NET.invokeGeneric "Remove" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

removeAll :: (NET.Type gT) => NET.System.Predicate.Predicate a0 gT -> List obj  gT -> IO (Data.Int.Int32)
removeAll arg0 obj = NET.invokeGeneric "RemoveAll" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

removeAt :: (NET.Type gT) => Data.Int.Int32 -> List obj  gT -> IO (())
removeAt arg0 obj = NET.invokeGeneric "RemoveAt" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

removeRange :: (NET.Type gT) => Data.Int.Int32 -> Data.Int.Int32 -> List obj  gT -> IO (())
removeRange arg0 arg1 obj = NET.invokeGeneric "RemoveRange" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

reverse :: (NET.Type gT) => List obj  gT -> IO (())
reverse obj = NET.invokeGeneric "Reverse" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  ()  obj

reverse_1 :: (NET.Type gT) => Data.Int.Int32 -> Data.Int.Int32 -> List obj  gT -> IO (())
reverse_1 arg0 arg1 obj = NET.invokeGeneric "Reverse" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

sort :: (NET.Type gT) => List obj  gT -> IO (())
sort obj = NET.invokeGeneric "Sort" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  ()  obj

sort_1 :: (NET.Type gT, NET.System.Collections.Generic.IComparer.IComparer (objTy_0 t0  gT)) => NET.Object (objTy_0 t0  gT) -> List obj  gT -> IO (())
sort_1 arg0 obj = NET.invokeGeneric "Sort" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

sort_2 :: (NET.Type gT, NET.System.Collections.Generic.IComparer.IComparer (objTy_2 t2  gT)) => Data.Int.Int32 -> Data.Int.Int32 -> NET.Object (objTy_2 t2  gT) -> List obj  gT -> IO (())
sort_2 arg0 arg1 arg2 obj = NET.invokeGeneric "Sort" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1, arg2) obj

sort_3 :: (NET.Type gT) => NET.System.Comparison.Comparison a0 gT -> List obj  gT -> IO (())
sort_3 arg0 obj = NET.invokeGeneric "Sort" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

toArray :: (NET.Type gT, NET.Arg gT) => List obj  gT -> IO (NET.System.Array.Array (gT))
toArray obj = NET.invokeGeneric "ToArray" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  ()  obj

trimExcess :: (NET.Type gT) => List obj  gT -> IO (())
trimExcess obj = NET.invokeGeneric "TrimExcess" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  ()  obj

trueForAll :: (NET.Type gT) => NET.System.Predicate.Predicate a0 gT -> List obj  gT -> IO (Bool)
trueForAll arg0 obj = NET.invokeGeneric "TrueForAll" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

get_Capacity :: (NET.Type gT) => List obj  gT -> IO (Data.Int.Int32)
get_Capacity obj = NET.invokeGeneric "get_Capacity" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  ()  obj

set_Capacity :: (NET.Type gT) => Data.Int.Int32 -> List obj  gT -> IO (())
set_Capacity arg0 obj = NET.invokeGeneric "set_Capacity" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

get_Count :: (NET.Type gT) => List obj  gT -> IO (Data.Int.Int32)
get_Count obj = NET.invokeGeneric "get_Count" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  ()  obj

get_Item :: (NET.Type gT, NET.Result gT) => Data.Int.Int32 -> List obj  gT -> IO (gT)
get_Item arg0 obj = NET.invokeGeneric "get_Item" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

set_Item :: (NET.Type gT, NET.Arg gT) => Data.Int.Int32 -> gT -> List obj  gT -> IO (())
set_Item arg0 arg1 obj = NET.invokeGeneric "set_Item" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

add :: (NET.Type gT, NET.Arg gT) => gT -> List obj  gT -> IO (())
add arg0 obj = NET.invokeGeneric "Add" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

convertAll :: (NET.Type gT, NET.Type gTOutput) => NET.System.Converter.Converter a0 gT gTOutput -> List obj  gT -> IO (NET.System.Collections.Generic.List.List a1 gTOutput)
convertAll arg0 obj = NET.invokeGeneric "ConvertAll" ( NET.tyNameCons ( NET.t22 $ NET.t11 obj) $  NET.tyMethSplit $  NET.tyNameCons ( NET.t33 $ NET.t11 arg0) $  [])  (arg0) obj


