{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Collections.Generic.Queue ( module NET.System.Collections.Generic.Queue ) where

import qualified NET
import NET.System.Collections.Generic.Queue.Type as NET.System.Collections.Generic.Queue
import qualified Data.Int
import qualified NET.System.Array
import qualified NET.System.Collections.Generic.Queue.Enumerator.Type as NET.System.Collections.Generic.Queue.Enumerator
import qualified NET.System.Object

get_Count :: (NET.Type gT) => Queue obj  gT -> IO (Data.Int.Int32)
get_Count obj = NET.invokeGeneric "get_Count" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  ()  obj

clear :: (NET.Type gT) => Queue obj  gT -> IO (())
clear obj = NET.invokeGeneric "Clear" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  ()  obj

copyTo :: (NET.Type gT, NET.Arg gT) => NET.System.Array.Array (gT) -> Data.Int.Int32 -> Queue obj  gT -> IO (())
copyTo arg0 arg1 obj = NET.invokeGeneric "CopyTo" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  (arg0, arg1) obj

enqueue :: (NET.Type gT, NET.Arg gT) => gT -> Queue obj  gT -> IO (())
enqueue arg0 obj = NET.invokeGeneric "Enqueue" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

getEnumerator :: (NET.Type gT) => Queue obj  gT -> IO (NET.System.Collections.Generic.Queue.Enumerator.Enumerator a0 gT)
getEnumerator obj = NET.invokeGeneric "GetEnumerator" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  NET.tyMethSplit $  [])  ()  obj

dequeue :: (NET.Type gT, NET.Result gT) => Queue obj  gT -> IO (gT)
dequeue obj = NET.invokeGeneric "Dequeue" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  ()  obj

peek :: (NET.Type gT, NET.Result gT) => Queue obj  gT -> IO (gT)
peek obj = NET.invokeGeneric "Peek" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  ()  obj

contains :: (NET.Type gT, NET.Arg gT) => gT -> Queue obj  gT -> IO (Bool)
contains arg0 obj = NET.invokeGeneric "Contains" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  (arg0) obj

toArray :: (NET.Type gT, NET.Arg gT) => Queue obj  gT -> IO (NET.System.Array.Array (gT))
toArray obj = NET.invokeGeneric "ToArray" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  ()  obj

trimExcess :: (NET.Type gT) => Queue obj  gT -> IO (())
trimExcess obj = NET.invokeGeneric "TrimExcess" ( NET.tyNameCons ( {-D-}NET.t22 $ NET.t11 obj) $  [])  ()  obj


