{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Linq.ILookup ( module NET.System.Linq.ILookup ) where

import qualified NET
import NET.System.Linq.ILookup.Type as NET.System.Linq.ILookup
import qualified Data.Int
import qualified NET.System.Collections.Generic.IEnumerable.Type as NET.System.Collections.Generic.IEnumerable
import qualified NET.System.Object

get_Count :: (NET.Type gTKey, NET.Type gTElement, ILookup obj) => NET.Object (objTy obj  gTKey gTElement) -> IO (Data.Int.Int32)
get_Count obj = NET.invokeGeneric "get_Count" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  ()  obj

get_Item :: (NET.Type gTKey, NET.Type gTElement, NET.Arg gTKey, NET.System.Collections.Generic.IEnumerable.IEnumerable (objTy_1 t1  gTElement), ILookup obj) => gTKey -> NET.Object (objTy obj  gTKey gTElement) -> IO (NET.Object (objTy_1 t1  gTElement))
get_Item arg0 obj = NET.invokeGeneric "get_Item" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  NET.tyMethSplit $  [])  (arg0) obj

contains :: (NET.Type gTKey, NET.Type gTElement, NET.Arg gTKey, ILookup obj) => gTKey -> NET.Object (objTy obj  gTKey gTElement) -> IO (Bool)
contains arg0 obj = NET.invokeGeneric "Contains" ( NET.tyNameCons ( {-D-}NET.t32 $ NET.t11 obj) $  NET.tyNameCons ( {-D-}NET.t33 $ NET.t11 obj) $  [])  (arg0) obj


