module NET.System.String 
	( module NET.System.String,
	  module NET.System.String.Type
 	) where

import NET hiding ( Object, new )
import NET.System.Object
import NET.System.String.Type

{-
new :: String -> IO (String ())
new str = newString str
-}

empty :: IO (StringTy a)
empty = getFieldStatic "System.String" "Empty" ()

charAt :: Int -> StringTy a -> IO Char
charAt = invoke "get_Chars"

lengthString :: StringTy a -> IO Int
lengthString = invoke "get_Length" ()

clone :: StringTy a -> IO (StringTy a)
clone = invoke "Clone" ()

endsWith :: String -> StringTy a -> IO Bool
endsWith = invoke "EndsWith"

startsWith :: String -> StringTy a -> IO Bool
startsWith = invoke "StartsWith"
