{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.UriKind.Type ( module NET.System.UriKind.Type ) where

import qualified NET
import qualified NET.System.Type.Type as NET.System.Type
import qualified NET.System.Enum.Type as NET.System.Enum
import qualified NET.System.IComparable.Type as NET.System.IComparable
import qualified NET.System.IFormattable.Type as NET.System.IFormattable
import qualified NET.System.IConvertible.Type as NET.System.IConvertible

instance NET.System.IComparable.IComparable (UriKindTy) where
  instanceName_IComparable _ = "NET.System.UriKind.UriKind"

instance NET.System.IFormattable.IFormattable (UriKindTy) where
  instanceName_IFormattable _ = "NET.System.UriKind.UriKind"

instance NET.System.IConvertible.IConvertible (UriKindTy) where
  instanceName_IConvertible _ = "NET.System.UriKind.UriKind"

type UriKind a = Int
data UriKindTy
 = RelativeOrAbsolute
 | Absolute
 | Relative
  deriving ( Enum, Show, Read )
toUriKind :: UriKindTy -> UriKind ()
toUriKind tag = fromEnum tag

fromUriKind :: UriKind () -> UriKindTy
fromUriKind obj = toEnum obj

