/*
 * Copyright (c), 2009 Sigbjorn Finne <sof@forkIO.com>
 *
 * Some utility classes.
 *
 */
using System.Runtime.InteropServices;

[ComVisible(false)]
public class Pair<A,B> {
  A m_a;
  B m_b;
  
  public Pair(A a,B b) { m_a = a ; m_b = b; }
  public A Fst { 
    get { return m_a; }
    set { m_a = value; }
  }
  public B Snd { 
    get { return m_b; }
    set { m_b = value; }
  }
}

[ComVisible(false)]
public class Triple<A,B,C> {
  A m_a;
  B m_b;
  C m_c;
  
  public Triple(A a,B b,C c) { m_a = a ; m_b = b; m_c = c;}
  public A Fst3 { 
    get { return m_a; }
    set { m_a = value; }
  }
  public B Snd3 { 
    get { return m_b; }
    set { m_b = value; }
  }
  public C Thd3 { 
    get { return m_c; }
    set { m_c = value; }
  }
}
